#include "linkedlistnode.h"

namespace Datastructures {
	namespace Nodes {
		template <typename T>
		LinkedListNode<T>::LinkedListNode(T value, std::shared_ptr<LinkedListNode<T>> next) {
			this->value = value;
			this->next = next;
		}

		//Creates a new node, returning a smart pointer to a stack allocated object
		template <typename T>
		std::shared_ptr<LinkedListNode<T>> LinkedListNode<T>::create(T value, std::shared_ptr<LinkedListNode<T>> next) {
			return std::make_shared<LinkedListNode<T>>(value, next);
		}
	}
}